---
apiVersion: apps/v1
kind: Deployment
metadata:
  name: matrix-llm-bot
spec:
  replicas: 1
  selector:
    matchLabels:
      app: bot
  template:
    metadata:
      labels:
        app: bot
    spec:
      initContainers:
        - name: matrix-llm-bot-init
          image: curlimages/curl
          command: ["/bin/sh", "-c"]
          args:
            - "! [ -f ggml-vicuna-13b-4bit.bin ] && curl -L -O 'https://huggingface.co/eachadea/legacy-ggml-vicuna-13b-4bit/resolve/main/ggml-vicuna-13b-4bit.bin' ; cp ggml-vicuna-13b-4bit.bin /models-local/"
          workingDir: /models/
          volumeMounts:
            - name: bot-model
              mountPath: /models
            - name: bot-model-local
              mountPath: /models-local
      containers:
        - name: matrix-llm-bot
          image:
            "registry.ethz.ch/sis/experimental/matrix-llm-py-bot/matrix-llm-py-bot:main-20230515T0744"
          volumeMounts:
            - name: bot-model-local
              mountPath: /var/lib/matrix-llm-bot
              readOnly: true
            - name: bot-config
              mountPath: /etc/matrix-llm-bot/config.json
              subPath: config.json
              readOnly: true
            - name: bot-state
              mountPath: /var/cache/matrix-llm-bot
      volumes:
        - name: bot-model
          # Shared among multiple pods
          emptyDir: {}
        - name: bot-model-local
          # For local pod only (hopefully faster)
          emptyDir: {}
        - name: bot-config
          secret:
            secretName: bot-config
        - name: bot-state
          emptyDir: {}
